(****************************************************************
 ****************************************************************
 ***                                                          ***
 ***        Copyright (c) 2001 by -=Assarbad [GoP]=-          ***
 ***       ____________                 ___________           ***
 ***      /\   ________\               /\   _____  \          ***
 ***     /  \  \       /    __________/  \  \    \  \         ***
 ***     \   \  \   __/___ /\   _____  \  \  \____\  \        ***
 ***      \   \  \ /\___  \  \  \    \  \  \   _______\       ***
 ***       \   \  \ /   \  \  \  \    \  \  \  \      /       ***
 ***        \   \  \_____\  \  \  \____\  \  \  \____/        ***
 ***         \   \___________\  \__________\  \__\            ***
 ***          \  /           /  /          /  /  /            ***
 ***           \/___________/ \/__________/ \/__/             ***
 ***                                                          ***
 ***  May the source be with you, stranger ... :-)            ***
 ***                                                          ***
 ***  Greets from -=Assarbad [GoP]=- ...                      ***
 ***  Special greets go 2 Nico, Casper, SA, Pizza, Navarion...***
 ***[for questions/proposals drop a mail to Assarbad@ePost.de]***
 *****************************************ASCII by Assa [GoP]****
 ****************************************************************)
program PrtMon3vivi;

uses
  windows,
  messages,
  winspool;

{$DEFINE DEBUGGING}

const
  IDD_DIALOG1 = 101;
  IDI_ICON1 = 103;
  IDC_EDIT1 = 1000;
var
  appICon: HICON;

{$R main.res}
{$INCLUDE ATOI.pas}
{$INCLUDE FileExists.pas}
{$INCLUDE FormatString.pas}
{$INCLUDE PNotify.pas}

function GetErrorMessage(code: Integer): string;
var
  msg: PChar;
  flags: integer;

  function MAKELANGID(p, s: word): Integer;
  begin
    result := (s shl 10) or p
  end;

begin
  try
    flags := FORMAT_MESSAGE_ALLOCATE_BUFFER or FORMAT_MESSAGE_IGNORE_INSERTS or FORMAT_MESSAGE_FROM_SYSTEM;
    if FormatMessage(flags,
      nil,
      code,
      MAKELANGID(LANG_NEUTRAL, SUBLANG_NEUTRAL),
      pchar(@msg),
      0,
      nil) <> 0 then
      SetString(result, msg, lstrlen(msg));
    LocalFree(Integer(msg));
  finally
  end
end;

function dlgfunc(hwnd: hwnd; umsg: dword; wparam: wparam; lparam: lparam): bool; stdcall;
var
  rect: TRect;
begin
  result := true;
  case umsg of
    WM_INITDIALOG:
      begin
        SendMessage(hwnd, WM_SETICON, ICON_SMALL, appIcon);
        SendMessage(hwnd, WM_SETICON, ICON_BIG, appIcon);
{$IFDEF DEBUGGING}
        dbgwnd := GetDlgItem(hwnd, IDC_EDIT1);
{$ENDIF DEBUGGING}
        if not InitNotificationThreads then
          begin
{$IFDEF DEBUGGING}
            DebugOut('InitNotificationThreads() failed. No further error code');
{$ENDIF DEBUGGING}
          end;
      end;
    WM_SIZE:
      begin
        GetClientRect(hwnd, rect);
        MoveWindow(GetDlgItem(hwnd, IDC_EDIT1), rect.left, rect.top, rect.right - rect.left, rect.bottom - rect.top, true);
      end;
    WM_CLOSE:
      begin
        if not FInitNotificationThreads then
          begin
{$IFDEF DEBUGGING}
            DebugOut('FInitnotificationThreads() failed ... Windows will force the process/threads to end.');
{$ENDIF DEBUGGING}
          end;
        Sleep(1500);
        EndDialog(hWnd, 0);
      end;
  else
    result := false;
  end;
end;

begin
  appIcon := LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1));
  DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG1), 0, @DlgFunc);
end.

